<?php

/**
 * @file
 * Contains \Drupal\aws_cloud\Aws\Ec2\InstanceInterface.
 */

// Updated by yas 2016/07/06
// Updated by yas 2016/06/01
// Updated by yas 2016/05/31
// Updated by yas 2016/05/28
// Updated by yas 2016/05/25
// Updated by yas 2016/05/20
// Updated by yas 2016/05/19
// Updated by yas 2016/05/18
// Created by yas 2016/04/18.
namespace Drupal\aws_cloud\Aws\Ec2;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface defining an Instance entity.
 *
 * @ingroup aws_cloud
 */
interface InstanceInterface extends ContentEntityInterface, EntityOwnerInterface {
  // Add get/set methods for your configuration properties here.
  /**
   * {@inheritdoc}
   */
  public function getCloudContext();

  /**
   * {@inheritdoc}
   */
  public function getInstanceId();

  /**
   * {@inheritdoc}
   */
  public function getInstanceType();

  /**
   * {@inheritdoc}
   */
  public function getAvailabilityZone();

  /**
   * {@inheritdoc}
   */
  public function getInstanceState();

  /**
   * {@inheritdoc}
   */
  public function getPublicDns();

  /**
   * {@inheritdoc}
   */
  public function setPublicDns($dns);

  /**
   * {@inheritdoc}
   */
  public function getPublicIp();

  /**
   * {@inheritdoc}
   */
  public function getElasticIp();

  /**
   * {@inheritdoc}
   */
  public function getPrivateDns();

  /**
   * {@inheritdoc}
   */
  public function setPrivateDns($private_dns);

  /**
   * {@inheritdoc}
   */
  public function getPrivateIps();

  /**
   * {@inheritdoc}
   */
  public function setPrivateIps($private_ips);

  /**
   * {@inheritdoc}
   */
  public function getPrivateSecondaryIp();

  /**
   * {@inheritdoc}
   */
  public function setPrivateSecondaryIp($private_ip);

  /**
   * {@inheritdoc}
   */
  public function getKeyPairName();

  /**
   * {@inheritdoc}
   */
  public function isMonitoring();

  /**
   * {@inheritdoc}
   */
  public function setMonitoring($is_monitoring);

  /**
   * {@inheritdoc}
   */
  public function getMonitoring();

  /**
   * {@inheritdoc}
   */
  public function setLaunchTime($launch_time);

  /**
   * {@inheritdoc}
   */
  public function getLaunchTime();

  /**
   * {@inheritdoc}
   */
  public function getSecurityGroups();

  /**
   * {@inheritdoc}
   */
  public function getVpcId();

  /**
   * {@inheritdoc}
   */
  public function getSubnetId();

  /**
   * {@inheritdoc}
   */
  public function getNetworkInterfaces();

  /**
   * {@inheritdoc}
   */
  public function getSourceDestCheck();

  /**
   * {@inheritdoc}
   */
  public function getEbsOptimized();

  /**
   * {@inheritdoc}
   */
  public function getRootDeviceType();

  /**
   * {@inheritdoc}
   */
  public function getRootDevice();

  /**
   * {@inheritdoc}
   */
  public function getBlockDevices();

  /**
   * {@inheritdoc}
   */
  public function getScheduledEvents();

  /**
   * {@inheritdoc}
   */
  public function getImageId();

  /**
   * {@inheritdoc}
   */
  public function getPlatform();

  /**
   * {@inheritdoc}
   */
  public function getIamRole();

  /**
   * {@inheritdoc}
   */
  public function getTerminationProtection();

  /**
   * {@inheritdoc}
   */
  public function getLifecycle();

  /**
   * {@inheritdoc}
   */
  public function getAlarmStatus();

  /**
   * {@inheritdoc}
   */
  public function getKernelId();

  /**
   * {@inheritdoc}
   */
  public function getRamdiskId();

  /**
   * {@inheritdoc}
   */
  public function getPlacementGroup();

  /**
   * {@inheritdoc}
   */
  public function getVirtualization();

  /**
   * {@inheritdoc}
   */
  public function getReservation();

  /**
   * {@inheritdoc}
   */
  public function getAmiLaunchIndex();

  /**
   * {@inheritdoc}
   */
  public function getTenancy();

  /**
   * {@inheritdoc}
   */
  public function getHostId();

  /**
   * {@inheritdoc}
   */
  public function getAffinity();

  /**
   * {@inheritdoc}
   */
  public function getStateTransitionReason();

  /**
   * {@inheritdoc}
   */
  public function getLoginUsername();

  /**
   * {@inheritdoc}
   */
  public function getCloudType();

  /**
   * {@inheritdoc}
   */
  public function getUserData();

  /**
   * {@inheritdoc}
   */
  public function getMinCount();

  /**
   * {@inheritdoc}
   */
  public function getMaxCount();

  /**
   * {@inheritdoc}
   */
  public function setInstanceId($instance_id = '');

  /**
   * {@inheritdoc}
   */
  public function setInstanceState($state = '');

  /**
   * {@inheritdoc}
   */
  public function setElasticIp($elastic_ip = '');

  /**
   * {@inheritdoc}
   */
  public function setPublicIp($public_ip = '');

  /**
   * {@inheritdoc}
   */
  public function created();

  /**
   * {@inheritdoc}
   */
  public function changed();

  /**
   * {@inheritdoc}
   */
  public function getRefreshed();

  /**
   * {@inheritdoc}
   */
  public function setRefreshed($time);

  /**
   * {@inheritdoc}
   */
  public function setName($name);

  /**
   * Load an instance entity by the aws instance_id
   * @param $instance_id
   * @return mixed
   */
  public static function loadByInstanceId($instance_id);

  /**
   * Get the termination timestamp
   */
  public function getTerminationTimestamp();

  /**
   * Set the termination timestamp
   * @param $timestamp
   * @return mixed
   */
  public function setTerminationTimestamp($timestamp);

}
