<?php

/**
 * @file
 * Contains \Drupal\aws_cloud\Aws\Ec2\VolumeInterface.
 */

// Updated by yas 2016/06/04
// Updated by yas 2016/05/31
// Updated by yas 2016/05/28
// Updated by yas 2016/05/25
// Updated by yas 2016/05/20
// Updated by yas 2016/05/19
// Updated by yas 2016/05/18
// Updated by yas 2016/05/11
// Created by yas 2016/04/19.
namespace Drupal\aws_cloud\Aws\Ec2;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface defining an Volume entity.
 *
 * @ingroup aws_cloud
 */
interface VolumeInterface extends ContentEntityInterface, EntityOwnerInterface {
  // Add get/set methods for your configuration properties here.
  /**
   * {@inheritdoc}
   */
  public function getCloudContext();

  /**
   * {@inheritdoc}
   */
  public function getVolumeId();

  /**
   * {@inheritdoc}
   */
  public function setVolumeId(string $volume_id = '');

  /**
   * {@inheritdoc}
   */
  public function getSize();

  /**
   * {@inheritdoc}
   */
  public function getState();

  /**
   * {@inheritdoc}
   */
  public function setState(string $state = '');

  /**
   * {@inheritdoc}
   */
  public function getVolumeStatus();

  /**
   * {@inheritdoc}
   */
  public function getAttachmentInformation();

  /**
   * {@inheritdoc}
   */
  public function getVolumeType();

  /**
   * {@inheritdoc}
   */
  public function getProductCodes();

  /**
   * {@inheritdoc}
   */
  public function getIops();

  /**
   * {@inheritdoc}
   */
  public function getAlarmStatus();

  /**
   * {@inheritdoc}
   */
  public function getSnapshotId();

  /**
   * {@inheritdoc}
   */
  public function getAvailabilityZone();

  /**
   * {@inheritdoc}
   */
  public function getEncrypted();

  /**
   * {@inheritdoc}
   */
  public function getKmsKeyId();

  /**
   * {@inheritdoc}
   */
  public function getKmsKeyAliases();

  /**
   * {@inheritdoc}
   */
  public function getKmsKeyArn();

  /**
   * {@inheritdoc}
   */
  public function created();

  /**
   * {@inheritdoc}
   */
  public function setCreated($created = 0);

  /**
   * {@inheritdoc}
   */
  public function changed();

  /**
   * {@inheritdoc}
   */
  public function getRefreshed();

  /**
   * {@inheritdoc}
   */
  public function setRefreshed($time);

  /**
   * {@inheritdoc}
   */
/*
  public function setCloudContext($cloud_context);
*/
}
