<?php

namespace Drupal\Tests\aws_cloud\Unit\Service;

use Drupal\Tests\UnitTestCase;

use Drupal\aws_cloud\Service\AwsEc2Service;

/**
 * Tests AWS Cloud Service.
 *
 * @group AWS Cloud
 */
class AwsEc2ServiceTest extends UnitTestCase {
  protected function setUp() {
    $this->service = new AwsEc2ServiceMock(
      $this->getMock('Drupal\Core\Entity\EntityTypeManagerInterface'),
      $this->getMock('Drupal\Core\Logger\LoggerChannelFactoryInterface'),
      $this->getConfigFactoryStub([
        'aws_cloud.settings' => ['aws_cloud_test_mode' => TRUE]]
      ),
      $this->getMockBuilder('Drupal\Core\Messenger\Messenger')
        ->disableOriginalConstructor()
        ->getMock(),
      $this->getStringTranslationStub(),
      $this->getMock('Drupal\Core\Session\AccountInterface'),
      $this->getMock('Drupal\cloud\Plugin\CloudConfigPluginManagerInterface')
    );
  }

  public function testGetAvailabilityZones() {
    $random = $this->getRandomGenerator();

    $zones = [];
    $zones[] = $random->name(8, TRUE);
    $zones[] = $random->name(8, TRUE);
    $zones[] = $random->name(8, TRUE);

    $responseZones = [];
    $responseZones['AvailabilityZones'] = array_map(function($zone) {
      return ['ZoneName' => $zone];
    }, $zones);
    $this->service->setAvailabilityZonesForTest($responseZones);

    $expectedResult = array_combine($zones, $zones);
    $actualResult = $this->service->getAvailabilityZones();
    $this->assertSame($expectedResult, $actualResult);
  }

}
